// Revolty2 (X1) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x100*16*80];

D88 disk;
FILE *fp;

bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

int calc_sum(unsigned char *_ptr)
{
	unsigned char *_p = _ptr;
	int sum=0;
	for (int i=0; i<0x100; i++)
	{
		sum+=*(_p++);
	}
	sum&=0xffff;
	return sum;
}

struct fpos
{
	int trk;
	int sec;
	int size;
};

int main(int argc, char *argv[])
{
	char fname[11];
	int i;
	unsigned char id0[] = "REVOLTY II   Sys";
	int id1 = 0xaa77;
	int id2 = 0x2f48;
	int id3 = 0x1f5a;
	int dn = -1;

	// Disk 1
	struct fpos ma1[] =
	{
		{ 0x4b, 0x07, 0x0400 },
		{ 0x4b, 0x0b, 0x0b00 },
		{ 0x4c, 0x06, 0x0500 },
		{ 0x4c, 0x0b, 0x0400 },
		{ 0x4c, 0x0f, 0x0500 },
		{ 0x4d, 0x04, 0x0200 },
		{ 0x4d, 0x06, 0x0500 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// Disk 2
	struct fpos ma2[] =
	{
		{ 0x30, 0x10, 0x0b00 },
		{ 0x31, 0x0b, 0x0900 },
		{ 0x32, 0x04, 0x1700 },
		{ 0x33, 0x0b, 0x1000 },
		{ 0x34, 0x0b, 0x1300 },
		{ 0x35, 0x0e, 0x0900 },
		{ 0x36, 0x07, 0x0c00 },
		{ 0x37, 0x03, 0x1400 },
		{ 0x38, 0x07, 0x0800 },
		{ 0x38, 0x0f, 0x0400 },
		{ 0x39, 0x03, 0x0700 },
		{ 0x39, 0x0a, 0x0400 },
		{ 0x39, 0x0e, 0x1300 },
		{ 0x3b, 0x01, 0x0c00 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	// Disk 3
	struct fpos ma3[] =
	{
		{ 0x41, 0x08, 0x1400 },
		{ 0x42, 0x0c, 0x1300 },
		{ 0x43, 0x0f, 0x1200 },
		{ 0x45, 0x01, 0x1000 },
		{ 0x46, 0x01, 0x1600 },
		{ 0x47, 0x07, 0x0c00 },
//		{ 0x48, 0x03, 0x0900 },	// ?
		{ 0x48, 0x0c, 0x0900 },
		{ 0x49, 0x05, 0x1d00 },
		{ 0x4b, 0x0c, 0x0300 },
		{ 0x4b, 0x0f, 0x0e00 },
		{ 0x4c, 0x0d, 0x0400 },
		{ 0x4d, 0x01, 0x0a00 },
		{ 0x00, 0x00, 0x0000 },	// End of Data
	};

	if (argc < 2 || argc > 3)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
	}

	if (argc==3)
	{
		// fBXNԍw
		dn = *argv[2]-'0';
		if (dn<0 || dn>3)
		{
		fprintf(stderr, "Usage: %s [d88file] (DiskNo.)\n",argv[0]);
		return 1;
		}
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (int d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x10);
		disk.ReadDATA1(0x00, 0x00, 0x00, 0x01, 0x01, buff, 0x100);

		if ((!memcmp(&buff[1], id0, sizeof(id0)-1) && dn==-1) || dn==0)
		{
			printf("Disk 0 F܂.\n");
			fcut("DEMO", 0x4c, 0x26, 0x00, 0x01, 0x01, 0x0000, 0x1000);
		}
		else if ((calc_sum(buff)==id1 && dn==-1) || dn==1)
		{
			printf("Disk 1 F܂.\n");
			for (i=0; ma1[i].trk; i++)
			{
				sprintf(fname,"MUS1%02d",i);
				fcut(fname, ma1[i].trk, ma1[i].trk>>1, ma1[i].trk&1, ma1[i].sec, 0x01, 0x0000, ma1[i].size);
			}
		}
		else if ((calc_sum(buff)==id2 && dn==-1) || dn==2)
		{
			printf("Disk 2 F܂.\n");
			for (i=0; ma2[i].trk; i++)
			{
				sprintf(fname,"MUS2%02d",i);
				fcut(fname, ma2[i].trk, ma2[i].trk>>1, ma2[i].trk&1, ma2[i].sec, 0x01, 0x0000, ma2[i].size);
			}
		}
		else if ((calc_sum(buff)==id3 && dn==-1) || dn==3)
		{
			printf("Disk 3 F܂.\n");
			for (i=0; ma3[i].trk; i++)
			{
				sprintf(fname,"MUS3%02d",i);
				fcut(fname, ma3[i].trk, ma3[i].trk>>1, ma3[i].trk&1, ma3[i].sec, 0x01, 0x0000, ma3[i].size);
			}
		}
	}
	return 0;
}

